function [CHAIN,options_]=RepExMCMC(PP,options_,varargin)

% % % % % % Input:


data=varargin{1}{2};

nreplic1=options_.mh_replic;
replic=options_.mh_exchangeint;
options_.mh_replic=replic;



CHAIN=[];
S2CHAIN=[];
SSCHAIN=[];
res=[];
naccepts=0;
for i=1:options_.mh_exchangeint:nreplic1
    PCHAIN=[];
    PRES=res;
    % % % % % % % % % % % % % % % % % % % % % % % % % %
    %     this part can be easily parallelized
    for j=1:options_.mh_nblck
        params0=PP(:,j);
        mh_bounds0=[options_.mh_params.low(j,:)' options_.mh_params.upp(j,:)'];
        [params]=CreateParams(params0, mh_bounds0,options_);

        [MarkovChain,params,options_]=AdaMCMC(data,params,options_);

        PCHAIN=[PCHAIN MarkovChain];
    end

    % % % % end of parallel part

    nchain=size(MarkovChain,2);

    for ii=1:nchain
        if options_.mh_exchangeind(ii)
            T1i=PP(ii,1);
            T2i=PP(ii,2);
            E1=PCHAIN(end,2*ii-1);
            E2=PCHAIN(end,2*ii);
            % %     tst = exp(-0.5*( sum((ss1-ss2)./sigma2) + newprior-oldprior) );
            ptst= exp((1/T1i - 1/T2i)*(E1 - E2));
            if ptst <= 0
                accept = 0;
            elseif ptst >= 1
                accept = 1;
                [ii naccepts];
                naccepts=naccepts+1;
                PP(ii,:)=PP(ii,2:-1:1);
            elseif ptst > rand
                accept = 1;
                [ii naccepts];
                naccepts=naccepts+1;
                PP(ii,:)=PP(ii,2:-1:1);
            else
                accept = 0;
            end
        end
    end
    CHAIN=[CHAIN; PCHAIN];
end



